AI = {}

function AI:getG(x, y)
	return anim8.newGrid(32, 32, x, y)
end

function AI:load()
end

function AI:calcVek(curr, dest)
	if curr < dest then
		return -1
	else
		return 1
	end
end


function AI:xIsCloser(x1, y1, x2, y2)
	local aX = math.abs(x2 - x1)
	local aY = math.abs(y2 - y1)
	if aX < aY then
		return false
	else 
		return true
	end
end
-- function AI:getTileCord(x, y)
-- 	return x - 16, y - 16
-- end
function AI:getTileCord(x, y)
	return x/2, y/2
end

local x_old = 0
local y_old = 0
function AI:update(dt)
	for i,j in ipairs(objects) do
		if j.oType == "bot" then
			--watcher.watch(3+i, "x "..j.currPosX)
			j.ani:update(dt)
			-- AI
			if(j.currPosX == nil) then
				x_old = j.currPosX
			end
			if(j.currPosY == nil) then
				y_old = j.currPosY
			end

			if AI:getTileCord(j.currPosX, j.currPosY) ~= AI:getTileCord(j.destPosX, j.destPosY) then
				-- optimize, calculate only once if possible
				local vekX = AI:calcVek(j.currPosX, j.destPosX)
				local vekY = AI:calcVek(j.currPosY, j.destPosY)
				local closerCord = AI:xIsCloser(j.currPosX, j.currPosY, j.destPosX, j.destPosY)
				local speed = j.speed * 10 * dt

				j.move = j.move + 1
				if j.move > speed then
					if closerCord then
						if vekX == 1 then
							j.currPosX = j.currPosX - 1
						end
						if vekX == -1 then
							j.currPosX = j.currPosX + 1
						end
					else
						if vekY == 1 then
							j.currPosY = j.currPosY - 1
						end
						if vekY == -1 then
							j.currPosY = j.currPosY + 1
						end
					end
					j.move = 0
				end
			else
				if j.dest then
					j.destPosX = j.trueDestX
					j.destPosY = j.trueDestY
					j.dest = false
				else
					j.destPosX = j.startPosX
					j.destPosY = j.startPosY
					j.dest = true
				end
			end
		end


	end
end

function AI:draw()
	for i, j in ipairs(objects) do
		if j.oType == "bot" then
			j.ani:draw(j.img, j.currPosX, j.currPosY, 0, 1, 1, 0, 0)
		end
	end
end

