bullets = {}

function bullets.load()
	bullets.speed = 200
end

function bullets.draw()
	love.graphics.push()
	love.graphics.translate(tx, ty)
	for i, v in ipairs(bullets) do
		love.graphics.draw(v.img, v.x, v.y)
	end
	-- for i, v in ipairs(bullets) do
	-- 	love.graphics.rectangle("fill",bump.getBBox(v))
	-- end
	love.graphics.pop()
end

function bullets.update(dt)
	for i, v in ipairs(bullets) do
		v.x = v.x + math.cos(v.angle) * dt * bullets.speed
		v.y = v.y + math.sin(v.angle) * dt * bullets.speed
		v.l = v.x
		v.t = v.y
	end

end

-- add shooting bullet on screen from point x1, y1, with angle
function bullets.addBullet(x1, y1, angle)
	if playerAmmoLeft > 0 then
		table.insert(bullets, {
			angle = angle,
			x = x1-tx,
			y = y1-ty,
			l = x1,
			t = y1,
			w = 16,		-- TODO remove hardcode
			h = 16,
			name = "bullet",
			img = love.graphics.newImage(img.."bullet.png")
		})
		playerAmmoLeft = playerAmmoLeft - 1
		bump.add(bullets[#bullets])
		audio.play(10, false, 0.4)			-- make a bullet!
	end
end

-- remove bullet from screen etc.
function bullets.removeBullet(bullet)
	for i,v in ipairs(bullets) do
		if v == bullet then
			-- swap
			local random = v
			bullets[i] = bullets[#bullets]
			bullets[#bullets] = random
			-- remove last element
			table.remove(bullets)
			break
		end
	end
end