gui = {}
gui.hp = {}
gui.hud = {}
gui.ammo = {}
gui.fear = {}
gui.reload = {}
gui.hp.StartHP = playerHP
gui.hp.hpSize = 32

gui.hud.sizeX = 0
gui.hud.sizeY = 0
gui.hud.mPrev = 0

gui.ammo.sizeX = 16
gui.ammo.sizeY = 32

gui.fear.sizeX = playerFearMax
gui.fear.sizeY = 32
gui.fear.timeCounter = 0
gui.fear.timeMax = 100

gui.reload.sizeX = 64
gui.reload.sizeY = gui.hud.sizeY

function gui.load()
		gui.hp.hpInit()
		gui.ammo.ammoInit()
		gui.reload.ReloadInit()
		gui.fear.fearInit()

		-- load nice font

		gui.nice_font = love.graphics.newFont("/assets/dirt2 soulstalker.otf", 72)
		gui.nice18_font = love.graphics.newFont("/assets/BebasNeue.otf", 26)
end

function gui.update(dt)

	musicCount = 0
	if playerFear <= 50 then musicCount = 1 end
	if playerFear > 50 then musicCount = 2 end
	if playerFear > 75 then musicCount = 3 end
	if gui.hud.mPrev ~= musicCount then
		audio.play(4 + musicCount, true, 0.4)
	end
	gui.hud.mPrev = musicCount
	if gui.fear.timeCounter < gui.fear.timeMax then
		gui.fear.timeCounter = gui.fear.timeCounter + 1
	else
		local tmp = ((playerFear * 0.05)  + 1)
		if playerFear - tmp > 0 then
			playerFear = playerFear - tmp
			gui.fear.timeCounter = 0
		else
			playerFear = 1
		end
	end
	if bulletReload - bulletReloadTime > 0 then
		bulletReload = bulletReload - 0.15 + bulletReloadTime/100
	else
		bulletReload = 0
	end
end

function gui.draw()
		-- draw hud background
		love.graphics.setColor(25, 25, 25, 175) -- change to helper // darkgrey
		love.graphics.rectangle("fill", gui.hud.getPosX(), gui.hud.getPosY(), gui.hud.sizeX, gui.hud.sizeY)
		love.graphics.setColor(255, 255, 255, 255)
		-- draw player hp hud [pos calculated by screen size(hardcoded)]
		for i=1, playerHP do
				love.graphics.draw(gui.hp.obj, (gui.hp.hpPosX - gui.hp.hpSize) + i * gui.hp.hpSize, gui.hp.hpPosY, 0, 1, 1, 0, 0)            
		end
		-- ammo
		local playerAmmoLeftTMP = playerAmmoLeft
		local alreadyDrawn = 0
		for i=1, playerAmmo do
			if playerAmmoLeftTMP ~= playerAmmo and alreadyDrawn <= playerAmmo then
			-- draw inactive
			love.graphics.draw(gui.ammo.objInactive, gui.ammo.StartPosX - gui.ammo.sizeX + i * gui.ammo.sizeX, gui.hud.getPosY(), 0, 1, 1, 0, 0)
			alreadyDrawn = alreadyDrawn + 1
			playerAmmoLeftTMP = playerAmmoLeftTMP + 1
		else
			-- draw active
			love.graphics.draw(gui.ammo.objActive, gui.ammo.StartPosX - gui.ammo.sizeX + i * gui.ammo.sizeX, gui.hud.getPosY(), 0, 1, 1, 0, 0)	
			alreadyDrawn = alreadyDrawn + 1
		end
		love.graphics.setColor(230, 205, 20, 255)
		love.graphics.rectangle("fill", gui.hud.getPosX() + playerFearMax, gui.hud.getPosY(), bulletReload, gui.hud.getPosY())
		love.graphics.setColor(255, 255, 255, 255)

		love.graphics.setColor(0, 120, 210, 255)
		love.graphics.rectangle("fill", gui.hud.getPosX(), gui.hud.getPosY(), playerFear, gui.hud.getPosY())
		love.graphics.setColor(255, 255, 255, 255)

		love.graphics.setFont(gui.nice18_font)
		love.graphics.print("stress bar", gui.hud.getPosX() + 5 , gui.hud.getPosY() + 2, 0, 1, 1, 0, 0)
		love.graphics.print("reload", gui.hud.getPosX() + gui.fear.sizeX , gui.hud.getPosY() + 2, 0, 1, 1, 0, 0)
		love.graphics.setFont(love.graphics.newFont(12))

		-- draw current level
		love.graphics.setColor(GRAY)
		love.graphics.setFont(gui.nice18_font)
		love.graphics.print("lvl "..map.name, 32, 32)
		love.graphics.setColor(WHITE)
	end

	-- draw game over if needed
	love.graphics.setFont(gui.nice_font)
	if game_state == "over" then
		audio.play(19, false, 0.4)
		love.graphics.print("game over", 410, 220)
	-- also draw "won" if finished
	elseif game_state == "won" then
		love.graphics.print("congratz, you've won the game!!!", 160, 220)
	elseif game_state == "pause" then
		love.graphics.print("pause", 465, 220)
	end
	love.graphics.setFont(love.graphics.newFont(12))

end
--shotgun reload hug
function gui.reload.ReloadInit()
	gui.hud.sizeX = gui.hud.sizeX + gui.reload.sizeX	
	bulletReload = gui.reload.sizeX
end
--fear unit gui
function gui.fear.fearInit()
	gui.hud.sizeX = gui.hud.sizeX + gui.fear.sizeX
end

function gui.hp:hpInit()
		gui.hp.obj = love.graphics.newImage(img .. "hp.png")

	-- calculate hp size
		gui.hp.sizeX = gui.hp.hpSize * gui.hp.StartHP
		-- add hp size to hud size
		gui.hud.sizeX = gui.hud.sizeX + gui.hp.sizeX
		gui.hp.hpPosX = love.graphics.getWidth() - gui.hp.sizeX 

		gui.hp.sizeY = gui.hp.hpSize
		gui.hud.sizeY = gui.hud.sizeY + gui.hp.sizeY
		gui.hp.hpPosY = love.graphics.getHeight() - gui.hp.sizeY
end

function gui.ammo:ammoInit()
	--load img
	gui.ammo.objInactive = love.graphics.newImage(img .. "inActiveAmmo.png")
	gui.ammo.objActive = love.graphics.newImage(img .. "activeAmmo.png")
	--calc ammo gui size and expand hud background
	gui.ammo.fullSizeX = gui.ammo.sizeX * playerAmmo
	gui.hud.sizeX = gui.hud.sizeX + gui.ammo.fullSizeX
	--calc ammo gui starting position X [pos calculated by gui hud background pos]
	gui.ammo.StartPosX = love.graphics.getWidth() - gui.hud.sizeX
end

-- calculate hud position
function gui.hud:getPosX()
	return love.graphics.getWidth() - gui.hud.sizeX
end
function gui.hud:getPosY()
	return love.graphics.getHeight() - gui.hud.sizeY
end

-- menu stuff
menu = {}

function menu.load()
	menu.img = love.graphics.newImage(img.."new_game.png")
	menu.img_c = love.graphics.newImage(img.."controls.png")

	-- load nice font
	menu.nice_font = love.graphics.newFont("/assets/dirt2 soulstalker.otf", 90)
	menu.text_font = love.graphics.newFont("/assets/Jellyka_Estrya_Handwriting.ttf", 64)
	menu.show_about = false
end

function menu.update(dt)

end

function menu.draw()
	local mx, my = love.mouse.getX(), love.mouse.getY()
	love.graphics.draw(menu.img, 0, 0)
	love.graphics.setFont(menu.nice_font)

	if menu.show_about == false then
		-- checking hower
		love.graphics.setColor(BLACK)
		if mx > 660 and my > 160 and mx < 940 and my < 240 then
			if (menu_same ~= 1) then
				audio.play(12, false, 0.8)
				menu_same = 1
			end
			love.graphics.setColor(RED)
			if love.mouse.isDown("l") then
				-- load first map
				map.load(1)
				-- start new game!

				game_state = "playing"
			end
		end
		love.graphics.print("new game", 660, 140)

		love.graphics.setColor(BLACK)
		if mx > 660 and my > 260 and mx < 940 and my < 340 then
			--audio.play(12, false, 0.4)
			love.graphics.setColor(RED)
			if love.mouse.isDown("l") then
				menu.show_about = true
			end
		end
		love.graphics.print("about", 660, 240)

		love.graphics.setColor(BLACK)
		if mx > 660 and my > 360 and mx < 940 and my < 440 then
			--audio.play(12, false, 0.4)
			love.graphics.setColor(RED)
			if love.mouse.isDown("l") then
				love.quit()
			end
		end
		love.graphics.print("exit", 660, 340)
	else
		-- story text
		love.graphics.setFont(menu.text_font)
		love.graphics.setColor(BLACK)
		love.graphics.printf("The world has fallen into darkness. "..
			"Apocalypse brought most of us into despair. Including you. "..
			"You find yourself in a dark hospital, filled with strange creatures. "..
			"Struggling to escape, trying to find your way out. You hear a pulse. "..
			"Your heartbeat. The only thing that keeps you alive...", 380, 40, 600, 'center')
		
		-- controls
		love.graphics.setColor(GRAY)
		love.graphics.draw(menu.img_c, 320, 180)
		love.graphics.setFont(menu.text_font)
		love.graphics.setColor(BLACK)
		love.graphics.print("l. click - fire", 670, 460)
		love.graphics.print("r. click - reload", 760, 360)
		love.graphics.print("running", 400, 340)
		love.graphics.print("quit", 400, 500)
		love.graphics.print("pause", 570, 520)


		-- back button
		love.graphics.setFont(menu.nice_font)
		love.graphics.setColor(BLACK)
		if mx > 660+200 and my > 160+300 and mx < 940+200 and my < 240+300 then
			--audio.play(12, false, 0.4)
			love.graphics.setColor(RED)
			if love.mouse.isDown("l") then
				-- go back
				menu.show_about = false
			end
		end
		love.graphics.print("back", 660+200, 140+320)

	end

	love.graphics.setColor(WHITE)
	love.graphics.setFont(love.graphics.newFont(12))
end