light = {}

function light.load()
	-- our "light"
	light.img = love.graphics.newImage(img.."light.png")
	light.state = "on"		-- other off

	-- pulse scale
	light.maxPulse = 1.4
	light.minPulse = 0.9
	light.currentPulse = 1.2

	-- pulsing speed and direction
	-- edited for fear levels
	light.pulseSpeed = 0.6 + fearLightScale
	light.pulseDir = 1 			-- other -1
	light.lx, light.ly = 0, 0
end

function light.draw()
	-- draw "light"
	if light.state == "on" then
		local sw, sh = love.graphics.getWidth(), love.graphics.getHeight() -- screen width, height
		local m = 600						-- magic value to draw stuff, so when scaling dow nothing shows
		love.graphics.translate(tx, ty)
		-- push to scale
		love.graphics.push()
		love.graphics.translate(player.x+16, player.y+16)
		love.graphics.scale(light.currentPulse)
		love.graphics.translate(-player.x-16, -player.y-16)

		light.lx=player.x-light.img:getWidth()/2+16
		light.ly=player.y-light.img:getHeight()/2+16
		love.graphics.draw(light.img, math.floor(light.lx), math.floor(light.ly))

		love.graphics.pop()
		love.graphics.translate(-tx, -ty)

		--watcher.watch(10, "player.x ".. player.x.." player.y ".. player.y)
		--watcher.watch(11, "tx ".. tx.." ty ".. ty)

		-- TODO - make not hardcoded!!
		-- push to scale (again)
		love.graphics.push()
		love.graphics.translate(sw/2+16, sh/2+16)
		love.graphics.scale(light.currentPulse)
		love.graphics.translate(-sw/2-16, -sh/2-16)

		love.graphics.setColor(BLACK)
		-- top
		love.graphics.rectangle("fill", 0-m, 0-m, sw+m, 70+32)
		-- bot
		love.graphics.rectangle("fill", 0-m, 570, sw+m, sh+m)
		--left
		love.graphics.rectangle("fill", 0-m, 0-m, 310, sh+m)
		--right
		love.graphics.rectangle("fill", sw-232, 0-m, sw+m, sh+m)
		love.graphics.pop()
		-- temp fix
		love.graphics.rectangle("fill", sw-100, sh-100, sw, sh)
		love.graphics.setColor(WHITE)
	end
end

function light.update(dt)
	-- switch pulse directions if needed
	if light.currentPulse < light.minPulse or
			light.currentPulse >= light.maxPulse then
		light.pulseDir = -light.pulseDir
	end

	light.currentPulse = light.currentPulse + light.pulseSpeed * light.pulseDir * dt
end