player = {}

-- tile_x, tile_y - on what tile to load player
function player.load(tile_x, tile_y)
	-- lives
	player.hp = 2

	-- moving speed
	player.speed = 28 + playerFear/4

	-- animation stuff
	player.img = love.graphics.newImage(img.."player.png")
	local g = anim8.newGrid(32, 32, player.img:getWidth(), player.img:getHeight())
  	player.ani = anim8.newAnimation('bounce', g('1-4,1'), 0.1, nil, false, true)
  	player.ani:pause()

  	-- position stuff
  	player.x, player.y = (tile_x-1)*32, (tile_y-1)*32	-- in pixels, from top left screen

  	-- moving states
  	player.mState = "stop"		-- other "move"

  	-- if need to flip player animation horizontaly
  	player.needFlip = false

  	-- calm music at first. will change later to more dynamic choices xD
  	
end


function player.draw()
	-- angle, to rotate animation to mouse
	player.rot = -math.angle(player.x+tx, player.y+ty, love.mouse.getX(), love.mouse.getY())

	-- draw player animation
	love.graphics.push()
	love.graphics.translate(tx, ty)
	love.graphics.translate((player.x + 16), (player.y + 16))
	love.graphics.rotate(player.rot)
	love.graphics.translate(-(player.x + 16), -(player.y + 16))
	player.ani:draw(player.img, player.x, player.y)

	if boxes then
		love.graphics.rectangle("fill", bump.getBBox(player))
	end
	
	love.graphics.pop()
end

function player.update(dt)
	player.hp  =  playerHP
	-- check if need to use animation
	for i, v in ipairs(zergs) do
		if inCircle(player.x, player.y, 32, v.l, v.t) then
			if playerFear + 1 < playerFearMax then
				playerFear = playerFear + 1
			end
		end
		if inCircle(player.x, player.y, 64, v.l, v.t) then
			if playerFear + 1 < playerFearMax then
				playerFear = playerFear + 0.2
			end
		end
		if inCircle(player.x, player.y, 86, v.l, v.t) then
			if playerFear + 1 < playerFearMax then
				playerFear = playerFear + 0.1
			end
		end
	end
	if player.mState ~= "stop" then
		player.ani:resume()
	else
		player.ani:pause()
		player.ani:gotoFrame(1)
	end
	if playerHP <= 0 then

		game_state = "over"
		audio.play(17, false, 0.4)
	end

	-- will need flip if end of animation
	if player.ani.position == 4 then
		player.needFlip = true
	end
	-- reverse if need flip
	if player.ani.position == 1 and player.needFlip == true then
		player.ani:flipH()
		player.needFlip = false
	end
	player.ani:update(dt)
end