zergs = {}

function zergs.load()
	zergs.speed = 20
	for i, v in ipairs(map.level("Objects").objects) do
		if v.type == "bot" then
			-- create the object
			local z = {
				name = v.name,
				l = v.x,
				t = v.y,
				w = 32,
				h = 32,
				-- make animation
				img  = love.graphics.newImage(img..string.sub(v.name, 0, 2)..".png"),
				type = v.type,
				dir = math.random(1, 4)		-- random moving direction!
			}
			local g = anim8.newGrid(32, 32, z.img:getWidth(), z.img:getHeight())
			z.ani = anim8.newAnimation('loop', g('1-4,1'), 0.1, nil, false, false)
			-- add to collision engine
			table.insert(zergs, z)
		end
	end
end

function zergs.update(dt)
	for i, v in ipairs(zergs) do
		v.ani:update(dt)
		-- update moving dir's
		-- up
		if v.dir == 3 then
			v.t = v.t - dt*zergs.speed
		-- down
		elseif v.dir == 1 then
			v.t = v.t + dt*zergs.speed
		-- left
		elseif v.dir == 2 then
			v.l = v.l - dt*zergs.speed
		-- right
		elseif v.dir == 4 then
			v.l = v.l + dt*zergs.speed
		end
	end
end

function zergs.draw()
	love.graphics.push()
	love.graphics.translate(tx, ty)
	for i, v in ipairs(zergs) do
		love.graphics.push()
		love.graphics.translate(v.l+v.w/2, v.t+v.h/2)
		love.graphics.rotate(math.rad(90)*v.dir+math.rad(90))
		love.graphics.translate(v.l, v.t)
		v.ani:draw(v.img, -v.l-v.w/2, -v.t-v.h/2)
		love.graphics.pop()
	end

	if boxes then
		for i, v in ipairs(zergs) do
			love.graphics.rectangle("fill", bump.getBBox(v))
			love.graphics.setFont(love.graphics.newFont(12))
			love.graphics.setColor(RED)
			love.graphics.print(v.type, v.l, v.t)
			love.graphics.setColor(WHITE)
		end
	end
	love.graphics.pop()
end

-- function removes bots
function zergs.removeZerg(zerg)
	for i,v in ipairs(zergs) do
		if v == zerg then
			-- swap
			local random = v
			zergs[i] = zergs[#zergs]
			zergs[#zergs] = random
			-- remove last element
			table.remove(zergs)
			break
		end
	end
end